#include <stdio.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "briefing_draw.h"
#include "mission.h"
#include "jstr.h"

void briefing_draw_init(void){
}

void draw_briefing(void){
    char title_buf[JBufSize(MISSION_TITLE_LEN_MAX)+16];
    int i, num, len;
    EzSetColorByRGB(255, 255, 255);
    sprintf(title_buf, "MISSION %d  %s",
            get_current_mission_no()+1,
            get_current_mission_title());
    len = jstrwidth(title_buf) * (FONTSIZE / 2);
    EzDrawStringB((WIN_WIDTH-len)/2, 32, title_buf);
    num = get_current_mission_briefing_num();
    for (i = 0 ; i < num ; i++){
        EzDrawStringB(8, i*20+52+20, get_current_mission_briefing(i));
    }


    /*
    int i;

    EzPutB((WIN_WIDTH-TITLE_LOGO_WIDTH)/2, 60, title_img);
    EzSetColorByRGB(255, 255, 255);
    EzSetFontSize(64);
    EzDrawStringB(100, 100, "SPACE");
    EzDrawStringB(100-32, 140, "WARRIOR");
    //    draw_sprite(500, 200, 96, 0, si_myrobo_turn_l9);
    //    draw_sprite(500, 300, 96, 1, si_myrobo_turn_l9);
    draw_sprite(450, 350, 128, di_b, si_asteroid);
    draw_sprite(500, 300, 96, di_b, si_myrobo_title);
    draw_sprite(100, 300, 128, di_b, si_drone_07);
    
    EzSetFontSize(16);
    EzSetColorByRGB(255, 255, 255);
    for (i = 0 ; i < ti_end ; i++){
        EzDrawStringB(MenuItemLTX, MenuItemRBY(i), menu_item_strs[i]);
    }
    EzDrawBoxB(MenuItemLTX-4, MenuItemLTY(cursor_pos)-2,
               MenuItemRBX+4, MenuItemRBY(cursor_pos)+2);
    */
    EzShowBuffer();
}
