#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <EzGraph.h>
#include "config.h"
#include "param.h"
#include "coordinate.h"
#include "obj.h"
#include "enemy_destroyer.h"
#include "rnd.h"
#include "uty.h"

static pos2_t turret_pos[] = {
    {  0, -10},
    {  0,  10},
    {-20,  -9},
    {-20,   9},
};

void enemy_destroyer_fire(obj_t *enemy_destroyer);

void setup_enemy_destroyer(obj_t *obj){
    obj->enemy_destroyer.fire_count = 0;
    obj->enemy_destroyer.turret = 0;
}

void act_enemy_destroyer(obj_t *obj){
    // zǼΥƤȤߤ
    if (abs(obj->rpos3.z) > RADAR_RANGE) return;

    //    printf("act destroyer fire:%d turret:%d\n", obj->enemy_destroyer.fire_count, obj->enemy_destroyer.turret);
    if (obj->enemy_destroyer.fire_count > 0){
        obj->enemy_destroyer.fire_count --;
    }
    enemy_destroyer_fire(obj);
}

void enemy_destroyer_fire(obj_t *enemy_destroyer){
    obj_t *obj;
    pos3_t pos3 = enemy_destroyer->pos3;
    dir_t dir;
    velo3_t velo3;
    //    int st;
    int dist, p;

    dir = enemy_destroyer->rpos3.z < 0 ? di_f : di_b;
    
    if (enemy_destroyer->enemy_destroyer.fire_count > 0) return;
    pos3.z += (dir == di_f ?
               enemy_destroyer->size/8 : -enemy_destroyer->size/8);
    pos3.x += turret_pos[enemy_destroyer->enemy_destroyer.turret].x;
    pos3.y += turret_pos[enemy_destroyer->enemy_destroyer.turret].y;

    dist = (int)Vec3Size(enemy_destroyer->rpos3);
    // ξ͡ķ֤˼ԤʤеʤϤǰΤ
    if (dist == 0) return; 
    velo3.x = -enemy_destroyer->rpos3.x * DESTROYER_BULLET_VELO / dist;
    velo3.y = -enemy_destroyer->rpos3.y * DESTROYER_BULLET_VELO / dist;
    velo3.z = -enemy_destroyer->rpos3.z * DESTROYER_BULLET_VELO / dist;
    p = RRnd(0, 9);
    if (p <=2) {
        velo3.x += RRnd(-1, 1);
    }
    else if (p <= 5) {
        velo3.y += RRnd(-1, 1);
    }
    /*
    velo3.z = (dir == di_f) ? DESTROYER_BULLET_VELO : -DESTROYER_BULLET_VELO;
    st = abs(enemy_destroyer->rpos3.z)/DESTROYER_BULLET_VELO;
    if (st != 0){
            velo3.x = -enemy_destroyer->rpos3.x / st + RRnd(-1, 1);
            velo3.y = -enemy_destroyer->rpos3.y / st + RRnd(-1, 1);
    }
    else { // ȤꤢZɸȤۤƱϷƤʤȤˤƤ
        return; 
    }
    */
    printf("fire (%d, %d, %d) velo(%d, %d, %d)\n", pos3.x, pos3.y, pos3.z,velo3.x, velo3.y, velo3.z);
        
    obj = create_obj(ot_enemybullet, pos3);
    set_destroyer_enemybullet(obj, velo3);
    enemy_destroyer->enemy_destroyer.fire_count = ENEMY_DESTROYER_FIRE_SPEED;
    IncCyclic(enemy_destroyer->enemy_destroyer.turret, 4);
}
