#ifndef LAYOUT_H
#define LAYOUT_H
#include "config.h"

#define WIN_WIDTH 640
#define WIN_HEIGHT 480

#define FONTSIZE 16
#define MENU_FONTSIZE 16

#define TITLE_MENU_LTY 260
#define TITLE_LOGO_WIDTH 360
#define TITLE_LOGO_HEIGHT 120


#define MISSION_SELECT_MENU_LTY 20

#define SCREEN_WIDTH 600
#define SCREEN_HEIGHT 480
#define SCREEN_OX (SCREEN_WIDTH/2)
#define SCREEN_OY (SCREEN_HEIGHT/2)

#define MAP_XSIZE 32
#define MAP_YSIZE ((SPACE_ZSIZE/SPACE_XSIZE)*MAP_XSIZE)

//#define MAP_LTY (0)
//MAP_LTY+MAP_YSIZE-1)
//#define MAP_RBX (WIN_WIDTH-1-1)
//#define MAP_RBY (WIN_HEIGHT-1-1)
//#define MAP_LTY (MAP_RBY-MAP_YSIZE+1)
//#define MAP_LTX (MAP_RBX-MAP_XSIZE-1)
#define MAP_LTY (1)
#define MAP_LTX (MAP_RBX-MAP_XSIZE+1)
#define MAP_RBX (WIN_WIDTH-1-1)
#define MAP_RBY (MAP_LTY + MAP_YSIZE-1)

#define RADAR_R 40
#define RADAR_IR ((int)(40*0.707))
#define RADAR_SIZE (RADAR_R*2)
//#define RADAR_YSIZE 80
//#define RADAR_ZSIZE 80
//#define RADAR_F_LTX (SCREEN_WIDTH + 4)
//#define RADAR_F_RBY (WIN_HEIGHT - 4)
//#define RADAR_F_LTY (RADAR_F_RBY-RADAR_SIZE+1)
#define RADAR_F_LTX (SCREEN_WIDTH/2-RADAR_R*2-4)
#define RADAR_F_LTY (4)
#define RADAR_F_RBX (RADAR_F_LTX+RADAR_SIZE-1)
#define RADAR_F_RBY (RADAR_F_LTY+RADAR_SIZE-1)
#define RADAR_F_X (RADAR_F_LTX+RADAR_R)
#define RADAR_F_Y (RADAR_F_LTY+RADAR_R)

#define RADAR_B_LTX (RADAR_F_RBX + 8)
#define RADAR_B_LTY (RADAR_F_LTY)
#define RADAR_B_RBX (RADAR_B_LTX+RADAR_XSIZE-1)
#define RADAR_B_RBY (RADAR_F_RBY)
#define RADAR_B_X (RADAR_B_LTX+RADAR_R)
#define RADAR_B_Y (RADAR_B_LTY+RADAR_R)

#define HP_BAR_WIDTH 100
#define HP_BAR_LTX (8)
#define HP_BAR_LTY (8)
#define HP_BAR_RBX (HP_BAR_LTX+HP_BAR_WIDTH)
#define HP_BAR_RBY (HP_BAR_LTY+16)

#define SPEED_BAR_WIDTH 100
#define SPEED_BAR_LTX (8)
#define SPEED_BAR_LTY (HP_BAR_RBY+8)
#define SPEED_BAR_RBX (SPEED_BAR_LTX+SPEED_BAR_WIDTH)
#define SPEED_BAR_RBY (SPEED_BAR_LTY+16)
#define SPEED_BAR_BASE (SPEED_BAR_LTX + SPEED_BAR_WIDTH/2)


#ifdef DEBUG
#define WSENSOR_XSIZE SCREEN_WIDTH
#define WSENSOR_YSIZE WSENSOR_XSIZE
#define WSENSOR_LTX 0
#define WSENSOR_LTY 0
#endif


#endif
