#include <stdio.h>
#include <stdlib.h>
#include <EzGraph.h>
#include "config.h"
#include "main_state.h"
#include "title.h"
#include "mission_select.h"
#include "briefing.h"
#include "game.h"
#include "file.h"


static main_state_t main_state;

main_state_t get_main_state(void){
    return main_state;
}

void set_main_state(main_state_t state){
    //    printf("set main state %d\n", state);
    switch (state){
    case ms_title:
        setup_title();
        break;
    case ms_mission_select:
        setup_mission_select();
        break;
    case ms_briefing:
        setup_briefing();
        break;
    case ms_game:
        setup_game();
        break;
    case ms_quit:
        EzExitEventLoop();
        break;
        /*
    case ms_stage_info:
        setup_stage_info();
        break;
    case ms_howtoplay:
        setup_howtoplay();
        break;
        */
    default:
        log_error("Unknown game state %d\n", state);
        exit(1);
    }
}








































