#ifndef SPRITE_H
#define SPRITE_H
#include "config.h"
#include "coordinate.h"

int sprite_init(void);

typedef enum {
    si_invalid = -1,
    si_begin = 0,
    si_asteroid = si_begin,
    si_myrobo,
    si_myrobo_title,
    si_myrobo_turn_l1,
    si_myrobo_turn_l2,
    si_myrobo_turn_l3,
    si_myrobo_turn_l4,
    si_myrobo_turn_l5,
    si_myrobo_turn_l6,
    si_myrobo_turn_l7,
    si_myrobo_turn_l8,
    si_myrobo_turn_l9,
    si_myrobo_turn_r1,
    si_myrobo_turn_r2,
    si_myrobo_turn_r3,
    si_myrobo_turn_r4,
    si_myrobo_turn_r5,
    si_myrobo_turn_r6,
    si_myrobo_turn_r7,
    si_myrobo_turn_r8,
    si_myrobo_turn_r9,
    si_dummy_target,
    si_enemy_destroyer,
    si_drone_00,
    si_drone_01,
    si_drone_02,
    si_drone_03,
    si_drone_04,
    si_drone_05,
    si_drone_06,
    si_drone_07,
    si_drone_08,
    si_drone_09,
    si_drone_10,
    si_drone_11,
    si_drone_12,
    si_drone_13,
    si_drone_14,
    si_drone_15,
    si_mine,
    si_explosion,
    si_end
    //    si_watermelon,
    //    si_chee,
    //    si_squid,
    //    si_chee = si_begin,
} sprite_id_t;

void draw_sprite(int x, int y, int size, dir_t dir, sprite_id_t sid);


#endif
