#ifndef UNIT_H
#define UNIT_H
#include "config.h"
#include "pos.h"

typedef enum {
    ut_myrobo, ut_asteroid,
} unit_type_t;

typedef struct {
    unit_type_t type;
    pos3d_t pos3d;
} unit_t;

void unit_init(void);
pos3d_t get_myrobo_pos3d(void);
pos3d_t get_unit_pos3d(int no);
void move_myrobo_x(int val);
void move_myrobo_y(int val);
void move_myrobo_z(int val);

#endif
