require 'fileutils'

pngpath = "png"
tmpfilename = "__tmp__"

filenames = Dir::entries(pngpath)

filenames.each do |filename|
  next unless filename.match(/\.png$/)
#  print "converting '#{filename}'\n"
  xpmfilename = filename.sub(/\.png$/, "\.xpm")
  cmd = "convert #{pngpath}/#{filename} #{xpmfilename}"
  puts cmd
  `#{cmd}`

  varname = xpmfilename.sub(/\./, '_')
  varname.sub!(/160/, '')
  varname.sub!(/96/, '')
  varname.sub!(/64/, '')

  fi = open(xpmfilename)
  xpm = fi.read
  fi.close

  xpm.sub!(/(static char \*)([a-zA-Z_]+)(\[\])/, "\\1#{varname}\\3")
  xpm.sub!(/\#000000/, "None")

  fo = open(tmpfilename, "w")
  fo.write(xpm)
  fo.close

  FileUtils.cp(tmpfilename, xpmfilename)
end



