#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "main_state.h"
#include "briefing.h"
#include "briefing_draw.h"

void briefing_keyh(int key);
void briefing_key_releaseh(int key);
void briefing_timerh(void);

void briefing_init(void){
    briefing_draw_init();
}

void setup_briefing(void){
    EzSetKeyHandler(briefing_keyh);
    EzSetKeyReleaseHandler(briefing_key_releaseh);
    EzSetTimerHandler(briefing_timerh, GAME_SPEED);
}

// 'q'ǽλʤ褦ΥϥɥĤäƤ
void briefing_keyh(int key){
}

void briefing_key_releaseh(int key){
    switch (key){
    case ' ':
    case 13:
    case 'x':
        set_main_state(ms_game);
        break;
    case 27:
    case 'q':
        set_main_state(ms_mission_select);
        break;
    default:
        break;
    }
}

void briefing_timerh(void){
    draw_briefing();
}

