#ifndef MAIN_STATE_H
#define MAIN_STATE_H
#include "config.h"

typedef enum {
    ms_title,
    ms_mission_select,
    ms_briefing,
    ms_game,
    ms_debriefing,
    ms_quit
} main_state_t;

extern unsigned char major_version;
extern unsigned char minor_version;
#define GetVersion(major, minor) (major*100+minor)


main_state_t get_main_state(void);
void set_main_state(main_state_t state);

#endif
