#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "unit.h"
#include "param.h"
#include "rnd.h"

static unit_t myrobo;
static unit_t units[UNIT_NUM_MAX];

void unit_init(void){
    int i;
    for (i = 0 ; i < UNIT_NUM_MAX ; i++){
        units[i].type = ut_asteroid;
        units[i].pos3d.x = RRnd(0, SPACE_XSIZE);
        units[i].pos3d.y = RRnd(0, SPACE_YSIZE);
        units[i].pos3d.z = RRnd(0, SPACE_ZSIZE);
        printf("%d %f %f %f\n", i, units[i].pos3d.x, units[i].pos3d.y, units[i].pos3d.z);
    }
    myrobo.type = ut_myrobo;
    myrobo.pos3d.x = SPACE_XSIZE/2;
    myrobo.pos3d.y = SPACE_YSIZE/2;
    myrobo.pos3d.z = SPACE_ZSIZE/2;
}

pos3d_t get_myrobo_pos3d(void){
    return myrobo.pos3d;
}

pos3d_t get_unit_pos3d(int no){
    return units[no].pos3d;
}

void move_myrobo_x(int val){
    myrobo.pos3d.x += val;
}
void move_myrobo_y(int val){
    myrobo.pos3d.y += val;
}
void move_myrobo_z(int val){
    myrobo.pos3d.z += val;
}

